Index: trunk/LMDZ.MARS/libf/aeronomars/surfacearea.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/surfacearea.F	(revision 633)
+++ trunk/LMDZ.MARS/libf/aeronomars/surfacearea.F	(revision 635)
@@ -12,5 +12,5 @@
 !
 !     Franck Lefevre
-!     version 1.1 november 2011
+!     version 1.2 april 2012
 !==========================================================================
 
@@ -46,14 +46,28 @@
 ! local
 
-      integer l, ig
-      real rho                     ! density (kg/m3)
-      real dustnd                  ! uodated dust number density (kg/kg)
-      real icend                   ! uodated ice number density (kg/kg)
-      real ccntyp                  ! typical dust number density (#/kg)
-                                   ! (microphys = false)
-      real rdusttyp                ! typical dust radius (m)
-                                   ! (microphys = false)
+      integer    :: l, ig
+      real       :: rho                     ! density (kg/m3)
+      real       :: dustnd, icend           ! uodated dust and ice number densities (kg/kg)
+      real, save :: factor_ice, factor_dust ! multiplying factor to compute total surface area
+                                            ! from the mass-mean radius
+      real       :: sigma_ice, sigma_dust   ! variance of the ice and dust distributions
+      real       :: ccntyp                  ! typical dust number density (#/kg)
+                                            ! (microphys = false)
+      real       :: rdusttyp                ! typical dust radius (m)
+                                            ! (microphys = false)
+
+      logical, save :: firstcall = .true.
 
 !==========================================================================
+
+      if (firstcall) then ! compute the multiplying factors
+         sigma_dust  = varian
+         sigma_ice   = sqrt(log(nuice_sed + 1.))
+         factor_dust = exp(0.5*(log(sigma_dust))**2)
+         factor_ice  = exp(0.5*(log(sigma_ice))**2)
+         write(*,*) 'surfacearea : factor_dust = ', factor_dust 
+         write(*,*) 'surfacearea : factor_ice  = ', factor_ice 
+         firstcall = .false.
+      end if
 
       if (microphys) then ! improvedclouds
@@ -69,8 +83,8 @@
      $                + pdq(ig,l,igcm_ccn_number)*ptimestep
 !              dust surface area
-               surfdust(ig,l) = dustnd*rho*tauscaling(ig)
+               surfdust(ig,l) = factor_dust*dustnd*rho*tauscaling(ig)
      $                          *4.*pi*rdust(ig,l)**2
 !              ice surface area
-               surfice(ig,l)  = icend*rho*tauscaling(ig)
+               surfice(ig,l)  = factor_ice*icend*rho*tauscaling(ig)
      $                          *4.*pi*rice(ig,l)**2
             end do
@@ -88,10 +102,10 @@
                ccntyp = ccntyp/ccn_factor
                if (rice(ig,l) .gt. rdust(ig,l)) then
-                  surfdust(ig,l) = ccntyp*(ccn_factor - 1.)*rho
-     $                             *4.*pi*rdusttyp**2
-                  surfice(ig,l)  = ccntyp*4.*pi*rice(ig,l)**2
+                  surfdust(ig,l) = factor_dust*ccntyp*(ccn_factor - 1.)
+     $                             *rho*4.*pi*rdusttyp**2
+                  surfice(ig,l)  = factor_ice*ccntyp*4.*pi*rice(ig,l)**2
                else
-                  surfdust(ig,l) = ccntyp*ccn_factor*rho
-     $                             *4.*pi*rdusttyp**2
+                  surfdust(ig,l) = factor_dust*ccntyp*ccn_factor
+     $                             *rho*4.*pi*rdusttyp**2
                   surfice(ig,l)  = 0.
                end if
@@ -105,11 +119,9 @@
         call wstats(ngrid,"surfdust", "Dust surface area",
      $            "micron2 cm-3",3,surfdust*1.e6)
-      endif
-      call writediagfi(ngrid,"surfdust", "Dust cloud surface area",
-     $            "micron2 cm-3",3,surfdust*1.e6)
-      if (callstats) then
         call wstats(ngrid,"surfice", "Ice cloud surface area",
      $            "micron2 cm-3",3,surfice*1.e6)
       endif
+      call writediagfi(ngrid,"surfdust", "Dust surface area",
+     $            "micron2 cm-3",3,surfdust*1.e6)
       call writediagfi(ngrid,"surfice", "Ice cloud surface area",
      $            "micron2 cm-3",3,surfice*1.e6)
Index: trunk/LMDZ.MARS/libf/aeronomars/thermosphere.F
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/thermosphere.F	(revision 633)
+++ trunk/LMDZ.MARS/libf/aeronomars/thermosphere.F	(revision 635)
@@ -12,5 +12,5 @@
 #include "comdiurn.h"
 #include "param.h"
-#include "param_v3.h"
+#include "param_v4.h"
 #include "chimiedata.h"
 #include "conc.h"
@@ -58,5 +58,5 @@
       if (calleuv) then
         call zerophys(ngridmx*nlayermx,zdteuv)
-        call euvheat(pt,pdt,pplev,pplay,zzlay,dist_sol,
+        call euvheat(pt,pdt,pplev,pplay,zzlay,
      $               mu0,ptimestep,ptime,zday,pq,pdq,zdteuv)
       endif
@@ -79,5 +79,5 @@
       if (callmoldiff) THEN
         call zerophys(ngridmx*nlayermx*nqmx,zdqmoldiff)
-        call moldiff_red(pplay,pplev,pt,pdt,pq,pdq,ptimestep,
+        call moldiff(pplay,pplev,pt,pdt,pq,pdq,ptimestep,
      &                   zzlay,zdteuv,zdtconduc,zdqmoldiff)
       endif
Index: trunk/LMDZ.MARS/libf/phymars/callkeys.h
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/callkeys.h	(revision 633)
+++ trunk/LMDZ.MARS/libf/phymars/callkeys.h	(revision 635)
@@ -16,5 +16,5 @@
      
       COMMON/callkeys_i/iradia,iaervar,iddist,ilwd,ilwb,ilwn,ncouche    &
-     &   ,dustbin,nqchem_min,nltemodel,nircorr
+     &   ,dustbin,nltemodel,nircorr
      
       COMMON/callkeys_r/topdustref,solarcondate,semi,alphan,euveff,     &
@@ -54,5 +54,4 @@
       logical sedimentation,activice,water,microphys,caps
       logical photochem
-      integer nqchem_min
       integer nltemodel
       integer nircorr
Index: trunk/LMDZ.MARS/libf/phymars/callsedim.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/callsedim.F	(revision 633)
+++ trunk/LMDZ.MARS/libf/phymars/callsedim.F	(revision 635)
@@ -434,5 +434,6 @@
 c     Update the dust particle size "rdust"
 c     -------------------------------------
-      DO l = 1, nlay
+      if (doubleq) then
+       DO l = 1, nlay
         DO ig=1,ngrid
           rdust(ig,l)=
@@ -441,9 +442,11 @@
           rdust(ig,l)=min(max(rdust(ig,l),1.e-10),500.e-6)
         ENDDO
-      ENDDO
+       ENDDO
+      endif ! of if (doubleq)
       
 c     Update the ice particle size "rice"
 c     -------------------------------------
-      IF(scavenging) THEN 
+      if (water) then
+       IF(scavenging) THEN 
         DO l = 1, nlay
           DO ig=1,ngrid
@@ -464,5 +467,5 @@
           ENDDO
         ENDDO
-      ELSE
+       ELSE
         DO l = 1, nlay
           DO ig=1,ngrid
@@ -475,5 +478,6 @@
           ENDDO
         ENDDO
-      ENDIF
+       ENDIF ! of IF(scavenging)
+      endif ! of if (water)
 
       RETURN
Index: trunk/LMDZ.MARS/libf/phymars/initracer.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/initracer.F	(revision 633)
+++ trunk/LMDZ.MARS/libf/phymars/initracer.F	(revision 635)
@@ -24,8 +24,4 @@
 c                  q(iq=2) is the dust number mixing ratio 
 
-c   If (photochem.or.thermochem) there is "ncomp" chemical species (ncomp
-c   is set in aeronomars/chimiedata.h) using the ncomp iq values starting at
-c      iq=nqchem_min = dustbin+1   (nqchem_min is defined in inifis.F)
-c   
 c
 c   author: F.Forget
@@ -43,5 +39,4 @@
 #include "advtrac.h"
 #include "comgeomfi.h"
-#include "chimiedata.h"
 
 #include "surfdat.h"
@@ -55,5 +50,4 @@
 c       et al. (2002), a value of 25 has been deduced;
       real, parameter :: popratio = 25.
-      logical :: oldnames ! =.true. if old tracer naming convention (q01,...)
       character(len=20) :: txt ! to store some text
 
@@ -71,11 +65,8 @@
 c-----------------------------------------------------------------------
 
-      integer :: nqchem_start
-
 ! Initialization: get tracer names from the dynamics and check if we are
 !                 using 'old' tracer convention ('q01',q02',...)
 !                 or new convention (full tracer names)
       ! check if tracers have 'old' names
-      oldnames=.false.
       count=0
       do iq=1,nqmx
@@ -90,119 +81,16 @@
         write(*,*) "initracer: tracers seem to follow old naming ",
      &             "convention (q01,q02,...)"
-        write(*,*) "   => will work for now ... "
-        write(*,*) "      but you should run newstart to rename them"
-        oldnames=.true.
+        write(*,*) "you should run newstart to rename them"
+        stop
       endif
 
-      ! copy/set tracer names
-      if (oldnames) then ! old names (derived from iq & option values)
-        ! 1. dust:
-        if (dustbin.ne.0) then ! transported dust
-          do iq=1,dustbin
-            txt=" "
-            write(txt,'(a4,i2.2)') 'dust',iq
-            noms(iq)=txt
-            mmol(iq)=100.
-          enddo
-          ! special case if doubleq
-          if (doubleq) then
-            if (dustbin.ne.2) then
-              write(*,*) 'initracer: error expected dustbin=2'
-            else
-!              noms(1)='dust_mass'   ! dust mass mixing ratio
-!              noms(2)='dust_number' ! dust number mixing ratio
-! same as above, but avoid explict possible out-of-bounds on array
-               noms(1)='dust_mass'   ! dust mass mixing ratio
-               do iq=2,2
-               noms(iq)='dust_number' ! dust number mixing ratio
-               enddo
-            endif
-          endif
-        endif
-        ! 2. water & ice
-        if (water) then
-          noms(nqmx)='h2o_vap'
-          mmol(nqmx)=18.
-!            noms(nqmx-1)='h2o_ice'
-!            mmol(nqmx-1)=18.
-          !"loop" to avoid potential out-of-bounds in array
-          do iq=nqmx-1,nqmx-1
-            noms(iq)='h2o_ice'
-            mmol(iq)=18.
-          enddo
-        endif
-        ! 3. Chemistry
-        if (photochem .or. callthermos) then
-          if (doubleq) then
-            nqchem_start=3
-          else
-            nqchem_start=dustbin+1
-          end if
-          do iq=nqchem_start,nqchem_start+ncomp-2
-            noms(iq)=nomchem(iq-nqchem_start+1)
-            mmol(iq)=mmolchem(iq-nqchem_start+1)
-          enddo
-        endif ! of if (photochem .or. callthermos)
-        ! 4. Other tracers ????
-        if ((dustbin.eq.0).and.(.not.water)) then
-          noms(1)='co2'
-          mmol(1)=44
-          if (nqmx.eq.2) then
-            noms(nqmx)='Ar_N2'
-            mmol(nqmx)=30
-          endif
-        endif
-      else
-        ! copy tracer names from dynamics
-        do iq=1,nqmx
-          noms(iq)=tnom(iq)
-        enddo
-        ! mmol(:) array is initialized later (see below)
-      endif ! of if (oldnames)
-
-      ! special modification when using 'old' tracers:
-      ! qsurf(nqmx) was h2o ice whereas q(nqmx) was water vapour
-      ! and (if iceparty) q(nqmx-1) was null whereas q(nqmx-1) was water ice
-      if (oldnames.and.water) then
-        write(*,*)'initracer: moving surface water ice to index ',nqmx-1
-        ! "loop" to avoid potential out-of-bounds on arrays
-        do iq=nqmx-1,nqmx-1
-          qsurf(1:ngridmx,iq)=qsurf(1:ngridmx,iq+1)
-        enddo
-        qsurf(1:ngridmx,nqmx)=0
-      endif 
-      
-c------------------------------------------------------------
-c     Test Dimensions tracers
-c------------------------------------------------------------
-
-! Ehouarn: testing number of tracers is obsolete...
-!      if(photochem.or.thermochem) then
-!          if (water) then
-!              if ((dustbin+ncomp+2).ne.nqmx) then
-!                 print*,'initracer: tracer dimension problem:'
-!                 print*,"(dustbin+ncomp+2).ne.nqmx"
-!                 print*,"ncomp: ",ncomp
-!                 print*,"dustbin: ",dustbin
-!                 print*,"nqmx: ",nqmx
-!                 print*,'Change ncomp in chimiedata.h'
-!               endif
-!          else
-!              if ((dustbin+ncomp+1).ne.nqmx) then
-!                 print*,'initracer: tracer dimension problem:'
-!                 print*,"(dustbin+ncomp+1).ne.nqmx"
-!                 print*,"ncomp: ",ncomp
-!                 print*,"dustbin: ",dustbin
-!                 print*,"nqmx: ",nqmx
-!                 print*,'Change ncomp in chimiedata.h'
-!                 STOP
-!               endif
-!            endif
-!      endif
+      ! copy tracer names from dynamics
+      do iq=1,nqmx
+        noms(iq)=tnom(iq)
+      enddo
 
 c------------------------------------------------------------
 c         NAME and molar mass of the tracer 
 c------------------------------------------------------------
-
    
 ! Identify tracers by their names: (and set corresponding values of mmol)
@@ -246,6 +134,6 @@
       igcm_n2plus=0
       igcm_hplus=0
+      igcm_hco2plus=0
       igcm_elec=0
-
 
       ! 1. find dust tracers
@@ -432,4 +320,9 @@
           count=count+1
         endif
+        if (noms(iq).eq."hco2plus") then
+          igcm_hco2plus=iq
+          mmol(igcm_hco2plus)=45.
+          count=count+1
+        endif
         if (noms(iq).eq."elec") then
           igcm_elec=iq
@@ -454,7 +347,5 @@
         endif
 
-
       enddo ! of do iq=1,nqmx
-!      count=count+nbqchem
       
       ! check that we identified all tracers:
Index: trunk/LMDZ.MARS/libf/phymars/physiq.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/physiq.F	(revision 633)
+++ trunk/LMDZ.MARS/libf/phymars/physiq.F	(revision 635)
@@ -131,5 +131,5 @@
 #include "chimiedata.h"
 #include "param.h"
-#include "param_v3.h"
+#include "param_v4.h"
 #include "conc.h"
 
Index: trunk/LMDZ.MARS/libf/phymars/tracer.h
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/tracer.h	(revision 633)
+++ trunk/LMDZ.MARS/libf/phymars/tracer.h	(revision 635)
@@ -66,4 +66,5 @@
       integer :: igcm_n2plus 
       integer :: igcm_hplus
+      integer :: igcm_hco2plus
       integer :: igcm_elec
       ! other tracers
@@ -85,5 +86,5 @@
      & igcm_co2plus,igcm_oplus,igcm_o2plus,igcm_coplus,igcm_cplus,      &
      & igcm_nplus,igcm_noplus,igcm_n2plus,igcm_hplus,igcm_elec,         &
-     & igcm_ar_n2!,nbqchem,niqchem
+     & igcm_hco2plus,igcm_ar_n2!,nbqchem,niqchem
       COMMON/tracer3/noms
 !-----------------------------------------------------------------------
